import _toConsumableArray from "@babel/runtime/helpers/esm/toConsumableArray";
var _jsxFileName = "/home/travis/build/basaltinc/bedrock/components/pretty-code/src/pretty-code.jsx";
import React from 'react';
import pretty from 'pretty';
import js from 'refractor/lang/javascript';
import json from 'refractor/lang/json';
import jsx from 'refractor/lang/jsx';
import handlebars from 'refractor/lang/handlebars';
import markdown from 'refractor/lang/markdown';
import markup from 'refractor/lang/markup';
import markupTemplating from 'refractor/lang/markup-templating';
import scss from 'refractor/lang/scss';
import css from 'refractor/lang/css';
import cssExtras from 'refractor/lang/css-extras';
import php from 'refractor/lang/php';
import twig from 'refractor/lang/twig';
import bash from 'refractor/lang/bash';
import { PreStyles, CodeStyles, PrismTokenStyles } from './pretty-code.styles';
import mapChildren from './map-children';

var refractor = require('refractor/core.js');

export var availableLanguages = [];
[js, json, jsx, markdown, markup, handlebars, php, markupTemplating, scss, css, cssExtras, twig, bash].forEach(function (lang) {
  refractor.register(lang);
  availableLanguages.push.apply(availableLanguages, [lang.displayName].concat(_toConsumableArray(lang.aliases)));
}); // This is a currated suggested list useful for Schema Forms. We `filter` it at end to ensure it is correct.

export var languageList = ['scss', 'css', 'javascript', 'jsx', 'twig', 'html', 'handlebars', 'php', 'json', 'bash'].filter(function (lang) {
  return availableLanguages.includes(lang);
});
export var isLanguageSupported = function isLanguageSupported(lang) {
  return languageList.includes(lang);
};
availableLanguages.sort();

var CodeSnippet = function CodeSnippet(_ref) {
  var language = _ref.language,
      _ref$code = _ref.code,
      code = _ref$code === void 0 ? '' : _ref$code;

  // check to make sure the language being used is registered
  if (process.env.NODE_ENV !== 'production') {
    if (!refractor.registered(language)) {
      // eslint-disable-next-line no-console
      console.warn("No language definitions for '".concat(language, "' seems to be registered, did you forget to call `Refractor.registerLanguage()`?"));
      return React.createElement("p", {
        __source: {
          fileName: _jsxFileName,
          lineNumber: 69
        },
        __self: this
      }, "No language definitions for '".concat(language, "' seems to be registered"));
    }
  }

  var preppedCode = language === 'html' ? pretty(code.trim(), {
    ocd: true
  }) : code.trim();
  var ast = refractor.highlight(code, language); // @todo: possibly add marker support like in react-refractor
  // if (props.markers && props.markers.length > 0) {
  //   ast = addMarkers(ast, { markers: props.markers });
  // }

  var formattedCode = ast.length === 0 ? preppedCode : ast.map(mapChildren(0));
  return React.createElement(PreStyles, {
    __source: {
      fileName: _jsxFileName,
      lineNumber: 87
    },
    __self: this
  }, React.createElement(CodeStyles, {
    __source: {
      fileName: _jsxFileName,
      lineNumber: 88
    },
    __self: this
  }, React.createElement(PrismTokenStyles, {
    __source: {
      fileName: _jsxFileName,
      lineNumber: 89
    },
    __self: this
  }, formattedCode)));
};

export default CodeSnippet;
//# sourceMappingURL=pretty-code.js.map